#pragma once

#include <algorithm>
#include <iterator>

// 'std::min/max' workaround
#if defined(_WIN64)
#  define __WIN64__wa__std_max std::_MAX
#  define __WIN64__wa__std_min std::_MIN
#else
#  define __WIN64__wa__std_max std::max
#  define __WIN64__wa__std_min std::min
#endif

// 'string::clear' workaround
#if defined(_WIN64)
// NOTE: Latest SDK failed to declare the basic_string<T>::clear member
#  define __WIN64__wa__string_clear(str) str.erase(str.begin(), str.end())
#else
#  define __WIN64__wa__string_clear(str) str.clear()
#endif

// 'constructing a container from a range' workaround
#if defined(_WIN64)
// NOTE: Latest SDK failed to declare the 'range' constructor for a certain STL containers
// as a template member. Hence, using that range constructor for containers of different type  
// will be rejected by the compiler. Use the copy algorithm to workaround this.
#  define __WIN64__wa__range_ctor(_C,_c,_F,_L) \
     _C _c; \
     std::copy(_F, _L, std::inserter(_c,_c.begin()))
#else
#  define __WIN64__wa__range_ctor(_C,_c,_F,_L) \
     _C _c(_F,_L)
#endif

