#pragma once

#include "nvsg/nvsgapi.h"  // storage-class defines

namespace nvutil
{
  extern NVSG_API void AssertionFailed(const char* assertion, const char* file, unsigned int line, const char * function); 
} // namespace nvutil

#if defined(_DEBUG)
// assert macro
#if defined(LINUX)
#define __ASSERT(exp) \
  if (exp){ \
  } else { \
    nvutil::AssertionFailed(#exp, __FILE__, __LINE__, __func__); \
  }
#else
#include <assert.h>
#define __ASSERT assert
#endif

// verify the expression f succeeds
#define __VERIFY(f) __ASSERT(f);

// a compile time assert
#define __CTASSERT(exp) __CTASSERTi(exp,__LINE__)
#define __CTASSERTi(exp,line) __CTASSERTii(exp,line)
#define __CTASSERTii(exp,line) static int __ctassert__##line[(exp)!=0] = {0}

#else // non-debug configuration

#define __ASSERT(exp) static_cast<void>(0)
#define __VERIFY(f) (static_cast<void>(f))
#define __CTASSERT(exp)
#define __CTASSERTi(exp,cnt)
#define __CTASSERTii(exp,cnt)
#endif

